<script setup lang="ts">
import { computed, ref, watch, defineProps } from "vue";

interface Emits {
  (event: "timerStopped"): void;
}
interface Props {
  breakOnMount?: boolean;
}

const emit = defineEmits<Emits>();
const props = defineProps<Props>();
const initialTime = 120; // 2 minutes in seconds
const time = ref(Number(sessionStorage.getItem("timer")) || initialTime);
const isTimerRunning = ref(false);

let timer: NodeJS.Timer | null = null;

const formatTime = computed(() => {
  const minutes = Math.floor(time.value / 60);
  const seconds = time.value % 60;
  return `${String(minutes).padStart(2, "0")}:${String(seconds).padStart(
    2,
    "0"
  )}`;
});

const startTimer = () => {
  if (!isTimerRunning.value) {
    isTimerRunning.value = true;
    timer = setInterval(() => {
      time.value--;
      if (time.value === 0) {
        stopTimer();
        timerStopped();
      }
    }, 1000);
  }
};

const stopTimer = () => {
  if (isTimerRunning.value) {
    isTimerRunning.value = false;
    if (timer) {
      clearInterval(timer);
    }
  }
};

const resetTimer = () => {
  time.value = initialTime;
  isTimerRunning.value = false;
  if (timer) {
    clearInterval(timer);
  }
};

const clearTimeout = () => {
  if (timer) {
    clearInterval(timer);
  }
  sessionStorage.removeItem("timer");
};

const timerStopped = () => {
  emit("timerStopped");
};

watch(
  () => time.value,
  (val) => {
    sessionStorage.setItem("timer", String(val));
  }
);

defineExpose({ resetTimer, startTimer, clearTimeout });
if (!props.breakOnMount) {
  startTimer();
}
</script>

<template>
  {{ formatTime }}
</template>
